    /**
* Angular App Modules.
*
* @file Main Angular's application properties.
*/
import { NgModule, ApplicationRef, Injectable, Inject, ComponentFactoryResolver, Type } from '@angular/core';
import { HttpClientModule, HttpClient } from '@angular/common/http';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';

import { ClipService } from "./clip.service";
import { SearchFilterService } from "./search-filter.service";
import { CouponFilterService } from "./coupon-filter.service";
import { AppConfigService } from './app.config.service';
import { BoxtopService } from './boxtop.service';




// Angular's NgModule
@NgModule({
    declarations: [],
    imports: [
        BrowserModule,
        HttpClientModule,
        FormsModule
    ],
    providers: [
        ClipService,
        SearchFilterService,
        CouponFilterService,
        AppConfigService,
        BoxtopService
    ]
})
@Injectable()
export class CoreModule {}
