"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/**
 * Angular App Config Service.
 *
 * @file Main Angular's application service provider.
 */
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
require("rxjs/add/operator/take");
var http_2 = require("@angular/common/http");
var BehaviorSubject_1 = require("rxjs/BehaviorSubject");
//Services
var boxtop_service_1 = require("./boxtop.service");
// Window global declaration
function _window() {
    return window;
}
var AppConfigService = /** @class */ (function () {
    function AppConfigService(http, zone, objBoxTop) {
        this.http = http;
        this.objBoxTop = objBoxTop;
        this.rewardGridPath = '/content/www/{banner}/en/justforyou/rewards/rewards-details';
        this.objCoupons = {};
        this._arrPromoRule = [];
        this.shopCouponRefreshSource = new BehaviorSubject_1.BehaviorSubject(false);
        this.shopCouponRefresh = this.shopCouponRefreshSource.asObservable();
        this.rewardsRefreshSource = new BehaviorSubject_1.BehaviorSubject(false);
        this.rewardsRefresh = this.rewardsRefreshSource.asObservable();
        this.postUserInfoSource = new BehaviorSubject_1.BehaviorSubject("");
        this.userInfoRefresh = this.postUserInfoSource.asObservable();
        this.checkBoxTopRegistered = function () {
            var _this = this;
            if (window['AB'].isWWW && window["AB"].COMMON.authorizeJ4U()) {
                this.userInfoRefresh.subscribe(function (data) {
                    if (data == 'initFunc') {
                        if (window['AB'].isWWW && window["AB"].COMMON.authorizeJ4U() && (!window["AB"].userInfo.boxTopCalled)) {
                            window["AB"].userInfo.boxTopCalled = true;
                            if (localStorage.getItem('loyaltyPartners')) {
                                var boxtopData = JSON.parse(localStorage.getItem('loyaltyPartners'));
                                if (boxtopData['loyaltyPartners']) {
                                    boxtopData['loyaltyPartners'].forEach(function (loyaltyPartner) {
                                        if ((loyaltyPartner) && (loyaltyPartner.name == 'GeneralMills') && (loyaltyPartner.planNumber) && (loyaltyPartner.planNumber.length > 1)) {
                                            window['AB'].userInfo.boxTopAuth = true;
                                        }
                                    });
                                }
                            }
                            else {
                                _this.objBoxTop.getGeneralMillsId().subscribe(function (boxtopData) {
                                    localStorage.setItem('loyaltyPartners', JSON.stringify(boxtopData));
                                    if (boxtopData['loyaltyPartners']) {
                                        boxtopData['loyaltyPartners'].forEach(function (loyaltyPartner) {
                                            if ((loyaltyPartner) && (loyaltyPartner.name == "GeneralMills") && (loyaltyPartner.planNumber) && (loyaltyPartner.planNumber.length > 1)) {
                                                window["AB"].userInfo.boxTopAuth = true;
                                            }
                                        });
                                    }
                                });
                            }
                        }
                    }
                });
            }
        };
        this._arrPromoRule = _window().SWY.CONFIGSERVICE.getConfigforPromoDesc();
        window['appConfigServiceRef'] = {
            zone: zone,
            service: this,
        };
        this.checkBoxTopRegistered();
    }
    /**
     * Gets all hidden inputs to bring data into Angular application.
     *
     * @see app.module.ts
     */
    AppConfigService.prototype.getHiddenInputs = function () {
        var result = '';
        var wrapper = $('.js-gridDataParse');
        $('input[type="hidden"]', wrapper).each(function (i, el) {
            var $el = $(el);
            var val = $el.val();
            var elName = $el.attr('name');
            if (!val)
                return;
            switch (elName) {
                case 'gridDataSource':
                    window['AB'][elName] = JSON.parse(val);
                    break;
                case 'availableSorts':
                    window['AB'][elName] = [];
                    val.split(',').map(function (elVal) {
                        window['AB'][elName].push(elVal.trim());
                    });
                    break;
                default:
                    window['AB'][elName] = val.toString();
                    break;
            }
        });
    };
    AppConfigService.prototype.getPromorulesArray = function () {
        return this._arrPromoRule;
    };
    AppConfigService.prototype.getBogoLabel = function () {
        return _window().SWY.CONFIGSERVICE.getBannerConventions().buy_one_get_one_free;
    };
    AppConfigService.prototype.getPromoDescription = function () {
        return _window().SWY.CONFIGSERVICE.getBannerConventions().promoDescription;
    };
    AppConfigService.prototype.getPromoDescriptionAPI = function (product) {
        switch (product.promoType) {
            case 'P':
                product['promoTitle'] = this.getPromoDescription();
                product['offerText'] = '';
                break;
            case 'B':
            case 'M':
                product['promoTitle'] = this.getBogoLabel();
                product['offerText'] = product['promoText'];
                break;
        }
    };
    AppConfigService.prototype.getAppContext = function () {
        return _window().AB;
    };
    AppConfigService.prototype.getProductDetailPath = function () {
        return _window().AB.htmlProductDetailPath;
    };
    AppConfigService.prototype.getCouponDetailPathShop = function () {
        return _window().AB.htmlOfferDetailPathShop;
    };
    AppConfigService.prototype.getCouponDetailPathWww = function () {
        return _window().AB.htmlOfferDetailPathWww;
    };
    AppConfigService.prototype.getRewardGridPathWww = function () {
        return _window().AB.htmlRewardDetailPathWww;
    };
    AppConfigService.prototype.promoDescription = function (product) {
        var field = 'promoDescription';
        var newField = 'promoDescriptionVal';
        var priceColor = 'priceColor';
        var strPromoDesc = product.promoDescription;
        var found = false;
        if (!strPromoDesc) {
            return;
        }
        console.log('PRODUCT DESCRIPTION - DATA: ' + strPromoDesc);
        for (var i = 0; i < this._arrPromoRule.length && found === false; i++) {
            var objRule = this._arrPromoRule[i];
            if (strPromoDesc.match(objRule['rule'])) {
                product[newField] = objRule['value'];
                product[priceColor] = objRule['priceColor'];
                product['offerText'] = objRule['offerText'];
                found = true;
                objRule['showStrikeThrough'] == true && this.checkStrikeThrough(product);
                console.log('PRODUCT DESCRIPTION - MODIFIED: ' + product[newField]);
            }
        }
        if (found === false) {
            product[newField] = _window().SWY.CONFIGSERVICE.getBannerConventions().promoDescription;
            console.log('PRODUCT DESCRIPTION - DEFAULT: ' + product[newField]);
            product[priceColor] = true;
            this.checkStrikeThrough(product);
            product['offerText'] = '';
        }
    };
    AppConfigService.prototype.checkStrikeThrough = function (product) {
        if (product['promoType'] == 'P' && product['basePrice'] != null && product['price'] > 0.00 && product['basePrice'] > 0.00 && product['price'] < product['basePrice']) {
            product['showStrikeThrough'] = true;
        }
        else {
            product['showStrikeThrough'] = false;
        }
    };
    AppConfigService.prototype.getJ4UCoupons = function () {
        return JSON.parse(localStorage.getItem('abCoupons'));
    };
    AppConfigService.prototype.getCoupons = function (product) {
        var offers = 0, offersClipped = 0;
        var offersNotAvailable = false;
        var offerName = '';
        var offersArray = [], newOffersArray = [];
        if (product['upc'] != undefined) {
            while (product['upc'].split('').shift() === '0') {
                product['upc'] = product['upc'].substring(1, product['upc'].length);
            }
            // console.warn('WINDOW', _window().AB.COUPON.getCouponByUpc);
            // let arrCoupon: any = _window().AB.COUPON.getCouponByUpc(product['upc']);  -- this was the good one with
            // coupon js
            var arrCoupon = this.getCouponByUpc(product['upc']);
            // console.log(arrCoupon);
            if (arrCoupon.length > 0) {
                for (var i = 0; i < arrCoupon.length; i++) {
                    offers++;
                    offerName = arrCoupon[i];
                    offersArray.push(arrCoupon[i]);
                }
                product['offerCounter'] = offers;
                for (var offer in offersArray) {
                    if (offersArray[0].status == 'C') {
                        offersClipped++;
                        offersClipped < (offersArray.length - 1) ? offersNotAvailable = true : offersNotAvailable = false;
                    }
                }
                product['offersClipped'] = offersClipped;
                if (arrCoupon.length > 1) {
                    product['moreCouponText'] = "View All Coupons";
                    product['clipStatus'] = arrCoupon[0].status;
                    // product['couponsAvailable'] = "sd";
                }
                else {
                    var couponType = this.getCouponType(arrCoupon[0].offerType);
                    console.log("couponType", couponType);
                    product['couponText'] = couponType + ": " + arrCoupon[0].offerPrice;
                    product['couponCategory'] = arrCoupon[0].category;
                    product['showJ4U'] = (arrCoupon[0].offerType == 'PD') ? true : false;
                    product['clipStatus'] = arrCoupon[0].status;
                    product['offerId'] = arrCoupon[0].offerId;
                    console.log('PRODUCT COUPON OFFER ID ' + arrCoupon[0].offerId);
                }
            }
        }
    };
    AppConfigService.prototype.clipCoupon = function (couponId) {
        console.log('Clip the Coupon');
        _window().AB.COUPON.clipCoupon(couponId);
    };
    AppConfigService.prototype.isLSCompatible = function () {
        var test = 'test';
        try {
            if (typeof window['AB'].isLSEnabled == 'undefined') {
                localStorage.setItem(test, test);
                localStorage.removeItem(test);
                console.log("==== LOCAL STORAGE IS ENABLED ====");
                window['AB'].isLSEnabled = true;
            }
        }
        catch (e) {
            console.log("==== LOCAL STORAGE IS DISABLED ====");
            window['AB'].isLSEnabled = false;
        }
        return window['AB'].isLSEnabled;
    };
    AppConfigService.prototype._hasLSCoupons = function () {
        var objCoupons = this._get();
        var response = (objCoupons &&
            objCoupons["offers"] &&
            objCoupons["offersByUpc"]) ? true : false;
        if (response) {
            if (objCoupons['updatedTime'] != undefined) {
                var updatedTime = Date.parse(JSON.parse(objCoupons['updatedTime']));
                var currentTime = Date.parse(JSON.parse(JSON.stringify(new Date())));
                var timeDiff = (currentTime - updatedTime) / 60000;
                console.log(updatedTime, response && timeDiff);
                response = (response && timeDiff < 120) ? true : false;
            }
            else {
                response = false;
            }
        }
        return response;
    };
    AppConfigService.prototype._hasLSRewards = function () {
        var objRewards = this._getRewards();
        return (objRewards &&
            objRewards["grOffers"]) ? true : false;
    };
    AppConfigService.prototype._get = function () {
        var objCoupons = this.objCoupons;
        if (this.isLSCompatible() && Object.keys(objCoupons).length === 0) {
            var strCoupons = localStorage.getItem("abCoupons");
            try {
                if (strCoupons) {
                    objCoupons = JSON.parse(strCoupons);
                }
            }
            catch (e) {
                console.error("ERROR: COUPON - GETTING FROM LOCAL STORAGE");
                console.error(e);
            }
        }
        return objCoupons;
    };
    AppConfigService.prototype._getRewards = function () {
        var strRewards = localStorage.getItem("abRewards");
        var objRewards = {};
        try {
            objRewards = JSON.parse(strRewards);
        }
        catch (e) {
            console.error("ERROR: REWARDS - GETTING FROM LOCAL STORAGE");
            console.error(e);
        }
        return objRewards;
    };
    AppConfigService.prototype._hasLSDeals = function () {
        var objDeals = this._getDeals();
        return objDeals ? true : false;
    };
    AppConfigService.prototype._getDeals = function () {
        var strDeals = localStorage.getItem("abDeals");
        var objDeals = {};
        try {
            objDeals = JSON.parse(strDeals);
        }
        catch (e) {
            console.error("ERROR: DEAL - GETTING FROM LOCAL STORAGE");
            console.error(e);
        }
        return objDeals;
    };
    AppConfigService.prototype.loadRemoteCoupons = function () {
        var _this = this;
        var couponPath = '';
        if (_window().AB.COMMON.authorize()) {
            couponPath = _window().AB.offerRegisterPath;
        }
        else {
            couponPath = _window().AB.offerGuestPath;
        }
        couponPath += '?offerPgm=PD-CC';
        couponPath += '&storeId=' + _window().AB.userInfo.branchId;
        couponPath += '&transformOfferbyUpc=y';
        var httpOptions = { headers: new http_2.HttpHeaders(_window().AB.j4uHttpOptions) };
        this.http.get(couponPath, httpOptions)
            .take(1)
            .subscribe(function (objResponse) {
            console.log('REMOTE COUPONS - ', objResponse);
            var objCoupons = objResponse;
            objCoupons['branchId'] = _window().AB.userInfo.branchId;
            _this._set(objCoupons);
            console.log("COUPON - FETCHED REMOTE STORAGE AND ADDED LOCAL STORAGE");
            _this.initCouponRelatedFunc();
        });
    };
    AppConfigService.prototype.isStoreChange = function () {
        var objCoupon = this._get();
        return (objCoupon['branchId'] == undefined || objCoupon['branchId'] != _window().AB.userInfo.branchId);
    };
    AppConfigService.prototype._set = function (coupons) {
        coupons['updatedTime'] = JSON.stringify(new Date());
        if (this.isLSCompatible()) {
            localStorage.setItem("abCoupons", JSON.stringify(coupons));
        }
        else {
            this.objCoupons = coupons;
        }
    };
    AppConfigService.prototype.initCouponRelatedFunc = function () {
        this.displayCouponInFullCart();
        this.shopCouponRefreshSource.next(true);
    };
    AppConfigService.prototype.isEmpty = function (obj) {
        // null and undefined are "empty"
        if (obj == null)
            return true;
        // Assume if it has a length property with a non-zero value
        // that that property is correct.
        if (obj.length > 0)
            return false;
        if (obj.length === 0)
            return true;
        // If it isn't an object at this point
        // it is empty, but it can't be anything *but* empty
        // Is it empty?  Depends on your application.
        if (typeof obj !== "object")
            return true;
        return true;
    };
    ///////////Get COUPON by UPC
    AppConfigService.prototype.getCouponByUpc = function (upc) {
        var arrCoupons = [];
        if (this._hasLSCoupons()) {
            var objCoupons = this._get();
            var arrCouponId = objCoupons.offersByUpc[upc];
            if (arrCouponId != undefined) {
                for (var index in arrCouponId) {
                    var strCouponId = arrCouponId[index];
                    var objCoupon = objCoupons.offers[strCouponId];
                    if (objCoupon != undefined) {
                        objCoupon['offerPgmLabel'] = this.getCouponType(objCoupon.offerPgm);
                        objCoupon['offerId'] = objCoupon.offerId;
                        objCoupon['status'] = (objCoupon['deleted']) ? 'U' : objCoupon['status'];
                        arrCoupons.push(objCoupon);
                    }
                }
            }
        }
        return arrCoupons;
    };
    /**
     * Check Unattended Delivery and restricted items.
     *
     * @returns {boolean} It's true if item is restricted and false if it's not restricted.
     */
    AppConfigService.prototype.checkUnAttendedDelivery = function (product) {
        if (window['AB'].COMMON.checkPendingOrder() && window['AB'].COMMON.checkUnAttendedDelivery() && product['restrictedValue'] && product['restrictedValue'] > 0)
            return true;
        else
            return false;
    };
    /**
     * Check if provided UPC has coupons in LocalStorage and returns true or folse
     *
     * @param {string} upc Product unique upc code.
     */
    AppConfigService.prototype.checkHasCouponsByUPC = function (upc) {
        if (!upc)
            return false;
        var couponsInLStorage = '';
        var couponsThisUpc = '';
        couponsInLStorage = this._get();
        if (!couponsInLStorage || !couponsInLStorage['offersByUpc'])
            return false;
        couponsThisUpc = couponsInLStorage['offersByUpc'][upc];
        if (!couponsThisUpc)
            return false;
        return (couponsThisUpc.length > 0);
    };
    /**
     *
     *
     *
     */
    AppConfigService.prototype.getCouponByAisleName = function (aisleName) {
        var arrCoupons = [];
        var objCoupons = this._get();
        if (!this.isEmpty(aisleName) && objCoupons.offers) {
            aisleName = aisleName.toLowerCase();
            for (var index in objCoupons.offers) {
                var objOffer = objCoupons.offers[index];
                if (objOffer.category.toLowerCase() === aisleName) {
                    objOffer['offerPgmLabel'] = this.getCouponType(objOffer.offerPgm);
                    arrCoupons.push(objOffer);
                }
            }
        }
        return arrCoupons;
    };
    AppConfigService.prototype.getClippedCouponByUpc = function (upc) {
        var _this = this;
        var allCoupons = [];
        var clippedCoupons = [];
        console.log('UPC: ' + upc);
        var objCoupons = this._get();
        if (objCoupons.offersByUpc && objCoupons.offers) {
            var couponIds = objCoupons.offersByUpc[upc];
            if (couponIds != undefined) {
                allCoupons = couponIds.map(function (x) {
                    var objCoupon = objCoupons.offers[x];
                    objCoupon['offerPgmLabel'] = _this.getCouponType(objCoupon['offerPgm']);
                    return objCoupon;
                }).filter(function (x) { return x != undefined; });
                clippedCoupons = allCoupons.filter(function (x) { return x.status == 'C'; });
            }
        }
        return {
            totalCoupons: allCoupons.length,
            totalClippedCoupons: clippedCoupons.length,
            clippedCoupons: clippedCoupons,
        };
    };
    AppConfigService.prototype.isClipped = function (offerId) {
        var response = false;
        console.log('Offer: ' + offerId);
        if (this._hasLSCoupons()) {
            var objCoupons = this._get();
            if (objCoupons.offers[offerId]) {
                var objCoupon = objCoupons.offers[offerId];
                objCoupon.status = (objCoupon.deleted) ? 'U' : objCoupon.status; //get status using the deleted flag
                response = (objCoupon != undefined && objCoupon.status == 'C');
            }
        }
        return response;
    };
    AppConfigService.prototype.displayCouponInFullCart = function () {
        var fullCartTotalCoupons = 0;
        var fullCartClippedCoupons = 0;
        var that = this;
        $('.j4u-clippedcoupons').each(function (index) {
            var strUpc = $(this).attr('data-upc');
            var objCoupon = that.getClippedCouponByUpc(strUpc);
            var arrCoupon = objCoupon.clippedCoupons;
            fullCartTotalCoupons += objCoupon.totalCoupons;
            fullCartClippedCoupons += objCoupon.totalClippedCoupons;
            if (arrCoupon.length > 0) {
                $('.id-cartimage').eq(index).prepend('<span class="svg-icon just-for-you-16px icon-u-absolute-full-cart"></span>');
            }
            for (var cIndex in arrCoupon) {
                var hCoupon = $('<div></div>');
                hCoupon.addClass('clipped-coupon-wrapper');
                hCoupon.append('<span class="svg-icon coupon-tick-mark"></span>');
                hCoupon.append('<span class="clipped-coupon-text">' + arrCoupon[cIndex].offerPgmLabel + ": " + arrCoupon[cIndex].offerPrice + "</span>");
                $(this).append(hCoupon);
            }
        });
        window['AB'].DATALAYER.updateCartSavings(fullCartTotalCoupons, fullCartClippedCoupons);
    };
    AppConfigService.prototype.getUpcByOffers = function (offerId) {
        var arrUpc = [];
        var objCoupons = this._get();
        if (objCoupons['offers'] && objCoupons['offers'] != null && objCoupons['offers'][offerId]) {
            for (var index in objCoupons['offersByUpc']) {
                var arrOfferId = objCoupons['offersByUpc'][index];
                if (arrOfferId.indexOf(offerId) != -1) {
                    arrUpc.push(index);
                }
            }
        }
        console.log('getUpcByOffers: Returning array of UPC ', arrUpc);
        return arrUpc;
    };
    AppConfigService.prototype.getOffer = function (offerId) {
        var objOffers = '';
        var objCoupons = this._get();
        if (objCoupons.offers && objCoupons.offers[offerId]) {
            objOffers = objCoupons.offers[offerId];
        }
        return objOffers;
    };
    /**
     * Get coupon type mapping.
     *
     * @param {string} type Coupon type: MF, PD, CC, SC.
     */
    AppConfigService.prototype.getCouponType = function (type) {
        var couponTypes = window['SWY'].CONFIGSERVICE.nimbusConfig.couponTypes;
        return (couponTypes[type] == undefined) ? '' : couponTypes[type];
    };
    AppConfigService.prototype.prop65WarningMessage = function (product) {
        var prop65Details = (window['SWY']['CONFIGSERVICE'].getProp65Details());
        product['prop65WarningTextDetails'] = "";
        if (prop65Details.prop65Flag) {
            product['prop65Title'] = "";
            product['prop65PdpTitle'] = "";
            if (product['prop65WarningText'] != null && product['prop65WarningText'] != "") {
                product['prop65Title'] = prop65Details.prop65Title;
                product['prop65PdpTitle'] = prop65Details.prop65PDPTitle;
                product['prop65WarningTextDetails'] = product['prop65WarningText'];
            }
        }
    };
    AppConfigService.prototype.initServiceCall = function () {
        console.log("ANGULAR - REQUESTED SERVICE CALL");
        this.postUserInfoSource.next("initAngular");
    };
    AppConfigService.prototype.updateEcomGalleryCoupon = function (couponId) {
        var objOffer = this.getOffer(couponId);
        if (objOffer != "") {
            var allCoupons = JSON.parse(localStorage.getItem('abCoupons'));
            allCoupons.offers[couponId].status = 'C';
            allCoupons.offers[couponId].deleted = false; //set deleted flag in localStorage
            localStorage.setItem('abCoupons', JSON.stringify(allCoupons));
        }
    };
    AppConfigService = tslib_1.__decorate([
        core_1.Injectable(),
        tslib_1.__metadata("design:paramtypes", [http_1.HttpClient, core_1.NgZone, boxtop_service_1.BoxtopService])
    ], AppConfigService);
    return AppConfigService;
}());
exports.AppConfigService = AppConfigService;
//# sourceMappingURL=app.config.service.js.map