import {Injectable} from '@angular/core';
import {BehaviorSubject} from 'rxjs/BehaviorSubject';

@Injectable()
export class SearchFilterService {

    /* Source Params */

    private searchSource = new BehaviorSubject<String>('');
    currentSearch = this.searchSource.asObservable();

    /* Filter Source Params */

    private filterSearchParamSource = new BehaviorSubject<String>('');
    currentFilterSearch = this.filterSearchParamSource.asObservable();

    public constructor() {
    }

    /* Set Params for Filters */

    public addSearchParam(param) {
        this.filterSearchParamSource.next(param)
    }

}
